import java.util.Properties;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;


public class JmsSenderJboss {

	private static final String DEFAULT_MESSAGE = "Hello, Worldtttttttttttttttttt";
	private static final String DEFAULT_CONNECTION_FACTORY = "jms/RemoteConnectionFactory";
	private static final String DEFAULT_DESTINATION = "jms/queue/test";
	private static final String DEFAULT_MESSAGE_COUNT = "1";
	private static final String DEFAULT_USERNAME = "guest";
	private static final String DEFAULT_PASSWORD = "guestpassword";
	private static final String INITIAL_CONTEXT_FACTORY = "org.jboss.naming.remote.client.InitialContextFactory";
	private static final String PROVIDER_URL = "remote://193.16.1.93:4447";
	private static final String PROVIDER_URL2 = "remote://193.16.1.67:4447";
	
	public static void main(String[] args) throws Exception {
		ConnectionFactory senderConnectionFactory = null;
		ConnectionFactory receiverConnectionFactory = null;
		Connection senderConnection = null;
		Connection receiverConnection = null;
		Session senderSession = null;
		Session receiverSession = null;
		MessageProducer producer = null;
		MessageConsumer consumer = null;
		Destination senderDestination = null;
		Destination receiverDestination = null;
		TextMessage message = null;
		Context senderContext = null;
		Context receiverContext = null;
		
		try{
			// setup the context
//			final Properties env = new Properties();
//			env.put(Context.INITIAL_CONTEXT_FACTORY, INITIAL_CONTEXT_FACTORY);
//			env.put(Context.PROVIDER_URL, System.getProperty(Context.PROVIDER_URL, PROVIDER_URL));
//			env.put(Context.SECURITY_PRINCIPAL, System.getProperty("username", DEFAULT_USERNAME));
//			env.put(Context.SECURITY_CREDENTIALS, System.getProperty("password", DEFAULT_PASSWORD));
//			senderContext = new InitialContext(env);
//			
//			//perform the JNDI lookup
			String connectionFactoryString = System.getProperty("connection.factory", DEFAULT_CONNECTION_FACTORY);
//			System.out.println("Attempting to acquire sender connection factory \"" + connectionFactoryString + "\"");
//			senderConnectionFactory = (ConnectionFactory) senderContext.lookup(connectionFactoryString);
//			System.out.println("Found sender connection factory \"" + connectionFactoryString + "\" in JNDI");
//			
			String destinationString = System.getProperty("destination", DEFAULT_DESTINATION);
//			System.out.println("Attempting to acquire sender destination \"" + destinationString + "\"");
//			senderDestination = (Destination) senderContext.lookup(destinationString);
//			System.out.println("Found sender destination \"" + destinationString + "\" in JNDI");
//			
//			// Create the JMS connection, session, producer, and consumer
//            senderConnection = senderConnectionFactory.createConnection(System.getProperty("username", DEFAULT_USERNAME), System.getProperty("password", DEFAULT_PASSWORD));
//            senderSession = senderConnection.createSession(false, Session.AUTO_ACKNOWLEDGE);
//            producer = senderSession.createProducer(senderDestination);
//            senderConnection.start();
//
//            int count = Integer.parseInt(System.getProperty("message.count", DEFAULT_MESSAGE_COUNT));
//            String content = System.getProperty("message.content", DEFAULT_MESSAGE);
//
//            System.out.println("Sending " + count + " messages with content: " + content);
//
//            // Send the specified number of messages
//            for (int i = 0; i < count; i++) {
//                message = senderSession.createTextMessage(content);
//                producer.send(message);
//            }

            
            
            System.out.println("-------------------------------------------------------------------------------------------");
            final Properties env2 = new Properties();
			env2.put(Context.INITIAL_CONTEXT_FACTORY, INITIAL_CONTEXT_FACTORY);
			env2.put(Context.PROVIDER_URL, System.getProperty(Context.PROVIDER_URL, PROVIDER_URL2));
			env2.put(Context.SECURITY_PRINCIPAL, System.getProperty("username", DEFAULT_USERNAME));
			env2.put(Context.SECURITY_CREDENTIALS, System.getProperty("password", DEFAULT_PASSWORD));
			receiverContext = new InitialContext(env2);
            
			System.out.println("Attempting to acquire receiver connection factory \"" + connectionFactoryString + "\"");
            receiverConnectionFactory = (ConnectionFactory) receiverContext.lookup(connectionFactoryString);
            System.out.println("Found receiver connection factory \"" + connectionFactoryString + "\" in JNDI");
            
            System.out.println("Attempting to acquire receiver destination \"" + destinationString + "\"");
            receiverDestination = (Destination) receiverContext.lookup(destinationString);
            System.out.println("Found receiver destination \"" + destinationString + "\" in JNDI");
            
            
            receiverConnection = receiverConnectionFactory.createConnection(System.getProperty("username", DEFAULT_USERNAME), System.getProperty("password", DEFAULT_PASSWORD));
            receiverSession = receiverConnection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            consumer = receiverSession.createConsumer(receiverDestination);
            receiverConnection.start();
            // Then receive the same number of messaes that were sent
            for (int i = 0; i < 3; i++) {
                message = (TextMessage) consumer.receive(5000);
                if(message != null){
                	System.out.println("Received message with content " + message.getText());
                }else{
                	System.out.println("Message is null");
                }
            }
		}catch (Exception e) {
			System.out.println(e.getMessage());
			throw e;
		}finally{
			if(senderContext != null){
				senderContext.close();
			}
			if(receiverContext!= null){
				receiverContext.close();
			}
			if(senderConnection != null){
				senderConnection.close();
			}
			if(receiverConnection!= null){
				receiverConnection.close();
			}
		}
	}
	
}
